// test.cpp: Dummy sample program.
// Starts notepad and waits till it exits.
#ifndef STRICT
#define STRICT
#endif
#include <windows.h>

void Close(HANDLE handle)
{
    if ( handle )
        CloseHandle(handle);
}

#include "handle.h"

int WINAPI WinMain(HINSTANCE, HINSTANCE, LPSTR, int)
{
    CAuto<HANDLE> x;      // Create unassigned CHandle object.
    STARTUPINFO si;
    GetStartupInfo(&si);
    PROCESS_INFORMATION pi;
    CreateProcess(NULL, "notepad.exe", NULL, NULL,
        FALSE, 0, NULL, NULL, &si, &pi);
        // Assign using assignment operator:
    x = pi.hProcess;
        // Assign using constructor:
    CAuto<HANDLE> y = pi.hThread; 
        // Closes previous handle in y and also resets x:
    y = x;    
        // Use y as if it was a regular HANDLE:
    WaitForSingleObject(y, INFINITE);
    return 0;
}                       // Close handle in y.
// End of File

